<template>
  <Layout>
    <Content>
      <Row v-if="!isLoading"
           class="login-wrapper"
           type="flex"
           justify="center"
           align="middle">
        <Col>
        <Card class="login-form">
          <p slot="title">Credentials please</p>
          <Form ref="form"
                :model="form"
                :rules="rules"
                @keyup.enter.native="handleSubmit('form')">
            <FormItem prop="username">
              <Input type="text"
                     v-model="form.username"
                     placeholder="Username">
              <Icon type="ios-person-outline"
                    slot="prepend"></Icon>
              </Input>
            </FormItem>
            <FormItem prop="password">
              <Input type="password"
                     v-model="form.password"
                     placeholder="Password">
              <Icon type="ios-lock-outline"
                    slot="prepend"></Icon>
              </Input>
            </FormItem>
            <FormItem>
              <Button type="primary"
                      @click="handleSubmit('form')">Signin</Button>
            </FormItem>
          </Form>
          <Spin size="large"
                fix
                v-if="sending"></Spin>
        </Card>
        </Col>
      </Row>
    </Content>
    <Footer>
      <Button to="/datenschutz">
        Datenschutzerklärung
      </Button>
    </Footer>
  </Layout>
</template>

<script>
import axios from "axios"
import routerGuard from "@/router/routerGuard"

export default {
  name: "Login",
  data: () => ({
    form: {
      username: null,
      password: null
    },
    rules: {
      username: [
        {
          required: true,
          message: "Please fill in the user name",
          trigger: "blur"
        }
      ],
      password: [
        {
          required: true,
          message: "Please fill in the password",
          trigger: "blur"
        },
        {
          type: "string",
          min: 6,
          message: "The password cannot be less than 6 characters",
          trigger: "blur"
        }
      ]
    },
    isLoading: true,
    sending: false,
    success: false
  }),
  methods: {
    handleSubmit(form) {
      this.$refs[form].validate(valid => {
        if (valid) {
          this.login()
          this.$Message.success("Please wait!")
        } else {
          this.$Message.error("Form is invalid!")
        }
      })
    },
    clearForm() {
      this.form.username = null
      this.form.password = null
    },
    login() {
      this.sending = true
      if (this.form.username != "" && this.form.password != "") {
        axios({
          method: "POST",
          url: this.$baseApiUrl + "/auth",
          data: this.form,
          headers: { "content-type": "application/json" }
        }).then(
          result => {
            console.log(result)
            this.sending = false
            this.success = true
            this.clearForm()
            this.$router.back()
          },
          error => {
            console.error(error)
            this.sending = false
            this.success = false
            this.clearForm()
            this.$Message.error("Failed to authenticate!")
          }
        )
      } else {
        this.$Message.error("An username and password must be present")
      }
    }
  },
  async mounted() {
    try {
      await routerGuard.checkLogin().then(result => {
        if (result) {
          this.$router.push({ name: "dashboard" })
        } else {
          this.isLoading = false
        }
      })
    } catch (error) {
      this.isLoading = false
      console.error(error)
    }
  }
}
</script>

<style lang="scss" scoped>
.login-form {
  width: 50vw;
}
</style>